#!/boot/home/config/bin/perl
#
# perl.SysInfo v1.0.0 - CGI Script to gather and report various system information.
# Copyright (c) 2000 Wade Majors <guru@startrek.com>
# Based upon SysWatch by Chris Martino <smirks@smirks.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



print "here?";

# All configuration is done with the sysinfo.conf file.

$config = "./sysinfo.conf";
require "$config";

##### Do NOT edit below here unless you know what you're doing!!  #####
# ------------------------------------------------------------------- #

$logs = "/var/log/syslog";
$temp_command;
@volinfo;
@df_info;
$info;
@show_list;
$vol_count= 0;
$volline;
$bad_line= "";
$sysdate = localtime;
chomp($sysdate);
$totaldisk= 0;
$totalfree= 0;

$sysos = `uname -sr`;
chomp($sysos);

if ($showuptime == 1) {
	$uptime = `uptime`;
	chomp($uptime);
};

$tmptop = '/tmp/tmptop';
$tmptail = '/tmp/tmptail';

if ($showcpu == 1) {

	$syscpu= "";
	$syscpu = `sysinfo -cpu | grep running | cut -d\\( -f1`;
	chomp($syscpu);
	$sysname = `uname -n`;
	chomp($sysname);
};

if ($showram == 1) {
	$memory = `expr \`sysinfo -mem | tr -s ' ' | cut -d' ' -f7 | cut -d\\) -f1\` / 1024 / 1024`;
	$memoryfree = `expr \`sysinfo -mem | tr -s ' ' | cut -d' ' -f1\` / 1024 / 1024`;
	chomp($memory);
	chomp($memoryfree);
	$memoryused = int($memory - $memoryfree);
};

if ($showswap == 1) {
	$swap = `expr \`ls -s /var/swap | tr -s ' ' |  cut -d' ' -f1\` / 1024`;
	chomp($swap);
};

if ($showsemaphores == 1) {
	$semaphore = `sysinfo -semaphore | tr -s ' ' | cut -d' ' -f8 | cut -d\\) -f1`;
	$semaphorefree = `sysinfo -semaphore | tr -s ' ' | cut -d' ' -f2`;
	chomp($semaphore);
	chomp($semaphorefree);
	$semaphoreused = int($semaphore - $semaphorefree);
};

if ($showthreads == 1) {
	$threads = `sysinfo -threads | tr -s ' ' | cut -d' ' -f8 | cut -d\\) -f1`;
	$threadsfree = `sysinfo -threads | tr -s ' ' | cut -d' ' -f2`;
	chomp($threads);
	chomp($threadsfree);  
	$threadsused = int($threads - $threadsfree);
};

if ($showteams == 1) {
	$teams = `sysinfo -teams | tr -s ' ' | cut -d' ' -f8 | cut -d\\) -f1`;
	$teamsfree = `sysinfo -teams | tr -s ' ' | cut -d' ' -f2`;
	chomp($teams);
	chomp($teamsfree); 
	$teamsused = int($teams - $teamsfree);
};

if ($showports == 1) {
	$ports = `sysinfo -ports | tr -s ' ' | cut -d' ' -f8 | cut -d\\) -f1`;
	$portsfree = `sysinfo -ports | tr -s ' ' | cut -d' ' -f2`;
	chomp($ports);
	chomp($portsfree); 
	$portsused = int($ports - $portsfree);
};


if ($showvolumes == 1) {
	@volinfo = `/bin/df`;

	foreach $volline ( @volinfo ) {
  
		chomp( $volline );
  
		if( $bad_line ne "" ) {
			$df_info[0]= $bad_line;
			($df_info[1], $df_info[2], $df_info[3], $df_info[4], $df_info[5] )
			= split( ' ', $volline);   
			$bad_line = "";
		} else {
			@df_info = split( ' ', $volline);
		}
    
		if( $df_info[1] ne "" ) {
			$bad_line = "";
		} else {
			# line was wrapped
			$bad_line= $df_info[0]; # save this for next pass
		};
    
  		if ((not (( $df_info[0] =~ /^Mount/ ) ||
			( in( $df_info[0], @exclude_vols ) ))) &&
			( $bad_line eq "")) {
				if( not( $df_info[0] =~ /^.*:.*$/ ) ) {
					$show_list[ $vol_count++]=[ @df_info ];
				};
		};
	};
};

if ($showhogs == 1) {
	open(OUTF,">>$tmptop");
	print OUTF `/bin/top -i 1 -n 1`;
	close(OUTF);
};

if ($showsyslog == 1) {
	open(OUTF,">>$tmptail");
	print OUTF " ";
	print OUTF `tail -$sysloglines /var/log/syslog`;
	close(OUTF);
}


print "Content-type: text/html\n\n";

print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\n<html>\n";
print "<head>\n";
print "<title>perl.SysInfo -&gt; $sysname</title>\n";
if ( $refresh == 1 ) {
	print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$interval\">\n";
}
print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
print "</head>\n";
print "<body bgcolor=\"$bgcolor\" text=\"$text\">\n<center>\n";
print "<table bgcolor=\"$tbgcolor\" width=522 border=0 cellpadding=2 cellspacing=0>\n";
print "<tr>\n<td width=522 height=23 bgcolor=\"$tdcolor\" colspan=1>\n";
print "<font color=\"$titlecolor\" face=\"arial, helvetica\" size=2>\n";
print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System Information";
print "</font>\n</td>\n</tr>\n";

print "<tr><td><font face=\"andale mono\" size=2><pre>";
print "SysInfo: $sysname\n";
print "&nbsp;     $sysos\n";
print "&nbsp;     $sysdate\n";

if ($showcpu == 1) {
	print "&nbsp;     $syscpu\n";
}

if ($showuptime == 1) {
	print "&nbsp;     $uptime\n";
}

print "</pre></font></td></tr></table>";

if ($showresources == 1) {

	print "<table width=522 bgcolor=\"$tbgcolor\" border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr>\n";
	print "<td height=\"23\" bgcolor=\"$tdcolor\" colspan=5>\n";
	print "<font color=\"$titlecolor\" face=\"arial, helvetica\" size=\"2\">\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Resource Information\n";
	print "</font>\n";
	print "</td>\n";   
	print "</tr>\n";
	print "<tr>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Resource</b></font></td>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Use</b></font></td>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Used</b></font></td>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Avail</b></font></td>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Total</b></font></td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td align=left><font face=\"arial, helvetica\" size=2>RAM</font></td>\n";
	print "<td align=left><font face=\"arial, helvetica\" size=2>";
	
	$percentused = 0;
	$percentused = int($memoryused / $memory *100);
	$imagesize = $percentused + 1;
	
	if ( $percentused < 90 ) {
		print "<img src=\"$image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	} else {
		print "<img src=\"$full_image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	};
	
	
	print "<td align=right><font face=\"arial, helvetica\" size=2>$memoryused\MB</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$memoryfree\MB</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$memory\MB</font></td>\n";
	
	print "</tr>\n";
	
	if ($showswap == 1) {
	print "<tr>\n";
	print "<td align=left><font face=\"arial, helvetica\" size=2>Swap</font></td>\n";
	print "<td align=left><font face=\"arial, helvetica\" size=2>&nbsp;</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>&nbsp;</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>&nbsp;</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$swap\MB</font></td>\n";
	
	print "</tr>";
	};
	
	if ($showsemaphores == 1) {
	print "<tr>\n";
	
	print "<td align=left><font face=\"arial, helvetica\" size=2>Semaphores</font></td>\n";
	print "<td align=left><font face=\"arial, helvetica\" size=2>";
	
	$percentused = 0;
	$percentused = int($semaphoreused / $semaphore *100);
	$imagesize = $percentused + 1;
	
	if ( $percentused < 90 ) {
		print "<img src=\"$image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	} else {
		print "<img src=\"$full_image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	};
	
	
	print "<td align=right><font face=\"arial, helvetica\" size=2>$semaphoreused</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$semaphorefree</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$semaphore</font></td>\n";
	

	print "</tr>";
	};
	
	if ($showthreads == 1) {
	print "<tr>\n";
	
	print "<td align=left><font face=\"arial, helvetica\" size=2>Threads</font></td>\n";
	print "<td align=left><font face=\"arial, helvetica\" size=2>";
	
	$percentused = 0;
	$percentused = int($threadsused / $threads *100);
	$imagesize = $percentused + 1;
	
	if ( $percentused < 90 ) {
		print "<img src=\"$image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	} else {
		print "<img src=\"$full_image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	};
	
	;
	print "<td align=right><font face=\"arial, helvetica\" size=2>$threadsused</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$threadsfree</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$threads</font></td>\n";

	print "</tr>";
	};
	
	if ($showteams == 1) {
	print "<tr>\n";
	
	print "<td align=left><font face=\"arial, helvetica\" size=2>Teams</font></td>\n";
	print "<td align=left><font face=\"arial, helvetica\" size=2>";
	
	$percentused = 0;
	$percentused = int($teamsused / $teams *100);
	$imagesize = $percentused + 1;
	
	if ( $percentused < 90 ) {
		print "<img src=\"$image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	} else {
		print "<img src=\"$full_image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	};
	
	
	print "<td align=right><font face=\"arial, helvetica\" size=2>$teamsused</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$teamsfree</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$teams</font></td>\n";

	print "</tr>";
	}
	
	if ($showports == 1) {
	print "<tr>\n";
	
	print "<td align=left><font face=\"arial, helvetica\" size=2>Ports</font></td>\n";
	print "<td align=left><font face=\"arial, helvetica\" size=2>";
	
	$percentused = 0;
	$percentused = int($portsused / $ports *100);
	$imagesize = $percentused + 1;
	
	if ( $percentused < 90 ) {
		print "<img src=\"$image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	} else {
		print "<img src=\"$full_image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
	};
	
	
	print "<td align=right><font face=\"arial, helvetica\" size=2>$portsused</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$portsfree</font></td>\n";
	print "<td align=right><font face=\"arial, helvetica\" size=2>$ports</font></td>\n";
	
	print "</tr>";
	};
	
	print "</table>\n<br><br>\n";

}

if ($showvolumes == 1) {
	print "<table width=522 bgcolor=\"$tbgcolor\" border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr>\n";
	print "<td height=23 bgcolor=\"$tdcolor\" colspan=6>\n";
	print "<font color=\"$titlecolor\" face=\"arial, helvetica\" size=2>\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Drive Information\n";
	print "</font>\n";
	print "</td>\n";   
	print "</tr>\n";
	print "<tr>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Mount</b></font></td>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Type</b></font></td>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Use</b></font></td>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Used</b></font></td>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Avail</b></font></td>\n";
	print "<td bgcolor=gray align=center><font face=\"arial, helvetica\" size=2><b>Size</b></font></td>\n";
	print "</tr>\n";
	
	if ($vol_count > 0) {
		foreach $item ( @show_list ) {
	  
		    $percentused = 0; # Used to graph the amount of disk space full
			if ( $item->[0] ne "----------------" ) {   # because of df's annoying ----'s
    			print "<tr>\n";
    			print "<td align=left><font face=\"arial, helvetica\" size=2>$item->[0]</font></td>\n";
				print "<td align=left><font face=\"arial, helvetica\" size=2>$item->[1]</font></td>\n";
    			print "<td align=left><font face=\"arial, helvetica\" size=2>\n";

				$usedspace = $item->[2] - $item->[3];
		
				if ( $usedspace != 0 ) {
					$percentused = int($usedspace / $item->[2] *100);
				};
				
				$imagesize = $percentused + 1;

				if ( $percentused == 0 ) {
		  			print "<img src=\"$image\" height=10 width=$imagesize> &nbsp; 0%</font></td>\n";
				} else {
		  			if ( $percentused < 90 ) {
		    			print "<img src=\"$image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
		  			} elsif (( $percentused >= 90) && ( $item->[4] =~ W )) {
		    			print "<img src=\"$full_image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
		  			} else {
		    			print "<img src=\"$ro_image\" height=10 width=$imagesize> &nbsp; $percentused\%</font></td>\n";
		  			};
       			};
				$usedspace = int($usedspace / 1024);
				$item->[3] = int($item->[3] / 1024);
				$item->[2] = int($item->[2] / 1024);
				print "<td align=right><font face=\"arial, helvetica\" size=2>$usedspace\MB</font></td>\n";
    			print "<td align=right><font face=\"arial, helvetica\" size=2>$item->[3]\MB</font></td>\n";
    			print "<td align=right><font face=\"arial, helvetica\" size=2>$item->[2]\MB</font></td>\n";
    			print "</tr>\n";
    	
    			# calc total disk space
    			if ( $item->[4] =~ W ) {	# only if writeable
    				$totaldisk = $totaldisk + $item->[2];
    				$totalfree = $totalfree + $item->[3];
    			}
   			}
	    }
	} else {	
	   print "<tr>\n";
	   print "<td align=center colspan=6><font face=\"arial, helvetica\" size=2>No Disk info avaible</font></td>\n";
	   print "</tr>\n";
	};
	
	
	print "</table><br><br>";

	print "<table width=522 bgcolor=\"$tbgcolor\" border=0 cellpadding=2 cellspacing=0>";
	print "<tr><td width=2 nowrap><font face=\"arial, helvetica\" size=2>Total writable disk space:</font></td><td><font face=\"arial, helvetica\" size=\"2\">$totaldisk\MB</font></td></tr>";
	print "<tr><td width=2 nowrap><font face=\"arial, helvetica\" size=2>Avail writable disk space:</font></td><td><font face=\"arial, helvetica\" size=\"2\">$totalfree\MB</font></td></tr>";
	print "</table>";
};

if ($showhogs == 1) {
	print "<p><table bgcolor=\"$tbgcolor\" width=522 border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr>\n";
	print "<td height=23 bgcolor=\"$tdcolor\" colspan=1>\n";
	print "<font color=\"$titlecolor\" face=\"arial, helvetica\" size=2>\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Process Information\n";
	print "</font>\n";
	print "</td>\n";
	print "</tr>\n";
	print "<tr><td><font face=\"courier\" size=\"2\"><pre>";
	open(INF, "$tmptop");
		@top = <INF>;
	close(INF);
	print "@top";
	print "</pre></font></td></tr></table>";
}
if ($showsyslog == 1) {
	print "\n";
	print "<p><table bgcolor=\"$tbgcolor\" width=522 border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr>\n";
	print "<td height=23 bgcolor=\"$tdcolor\" colspan=1>\n";
	print "<font color=\"$titlecolor\" face=\"arial, helvetica\" size=2>\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System Messages\n";
	print "</font>\n";
	print "</td>\n";
	print "</tr>\n";
	print "<tr><td><font face=\"courier\" size=2><pre>\n";
	open(INF, "$tmptail");
		@tail = <INF>;
	close(INF);
	print "\n@tail";
	print "</pre></font></td></tr></table>";
}
print "<hr><font face=\"arial\" size=1>Output produced by perl.SysInfo</font>\n";
print "</center></body></html>\n";

`rm $tmptop`;	# clean up
`rm $tmptail`;	# clean up

sub in { 

    $this= shift;
    @here=@_; 
    $found_it=0;

    for( $num=0; (($num < scalar( @here)) && ( ! $found_it )); $num++) {
        if( $here[ $num] eq $this ) {
            $found_it=1;
        };
    };
    return $found_it;
};
